# Changelog

## 4.3.0 - 2019-04-12 (Éditions LLL)

### Nouvelles fonctionnalités

 * Module "Passe à bassin : chute"
 * Module "Passe à bassin : nombre de bassins"
 * Amélioration du filtre de choix des paramètres liables
 * Vérification de la cohérence des paramètres liés au chargement de session
 * Validation et invalidation en cascade des modules de calcul liés
 * Calcul en cascade automatique des modules de calculs liés
 * Transfert de ngHyd vers JaLHyd des mécanismes gérant les états des paramètres des modules de calcul
 * Ajout des tags de version dans le panneau latéral
 * La touche TAB permet de passer directement d'un champ de saisie à un autre
 * Le bouton "+" disparaît sur la page d'accueil

### Correction de bogues

 * Divers bogues autour des paramètres liés
 * Mise à jour intempestive des paramètres calculés dans le formulaire de saisie
 * Précision d'affichage des données dans les infobulles

## 4.2.0 - 2019-03-11

### Nouvelles fonctionnalités

 * titres courts pour les modules, suffixe numérique automatique
 * Lechapt-Calmon : amélioration du sélecteur de matériau
 * affichage des valeurs liées
 * détection de la langue du navigateur
 * mémorisation des paramètres par le navigateur
 * mécanisme de langue de secours pour les modules non traduits
 * paramètres variables : courbe d'évolution
 * graphiques de résultats : choix libre de l'abscisse et de l'ordonnée

### Correction de bogues

 * déplacement de la sérialisation au niveau du modèle (JaLHyd)
 * nouvelle gestion des langues: plus robuste, charge moins de fichiers inutiles, ajout d'un cache
 * meilleure gestion de la session et de la hiérarchie (ouvrages en parallèle / parent)
 * gestion homogène de la touche entrée dans les formulaires : déclenche le calcul
 * la précision Pr est traitée comme un paramètre normal
 * simplification de la gestion des types d'ouvrages
 * désérialisation des ouvrages en parallèle
 * validation des ouvrages en parallèle
 * validation des paramètres variables
 * simplification et suppression de code inutilisé
 * affichage des icônes et polices hors-ligne
 * conservation du type de graphe lorsqu'on change de module
 * ajout de tests exhaustifs sur le calcul des paramètres et le clonage des modules

## 4.1.0 - 2019-02-20

### Nouvelles fonctionnalités

 * interface : angular-material, angular-flex, charte graphique Irstea
 * nouvelle page de liste, modules groupés par thèmes
 * ajout du module Passe à Enrochement
 * bouton pour vider la session
 * bouton pour cloner un module de calcul
 * fichier de configuration JSON, gestion d'une langue par défaut
 * paramètre variable : amélioration des listes de valeurs
 * affichage des graphiques et des tableaux de résultats en plein écran
 * export des graphiques en PNG
 * export des tableaux de résultats vers Excel
 * utilisation de chaînes pour les UID
 * utilisation de routerLink et des fragments d'URL (#)
 * ajout de tests e2e avec Protractor
 * limitation de la précision dans les graphiques

### Correction de bogues

 * redirection des URL invalides vers /list
 * chargement de paramètres liés
 * sauvegarde et chargement des valeurs des paramètres
 * IDs uniques dans les champs de formulaires
 * nettoyage du code (tslint)
 * suppression de code inutilisé
 * renommage et simplification de classes
 * amélioration de la traduction

### Mises à jour de dépendances

 * Angular 7.2
 * Compodoc
 * angular-material
 * angular-flex
 * suppression de MDBootstrap
 * suppression de FontAwesome

## 4.0.0 - 2018-07-23
